use news_flash::models::{ArticleFilter, ArticleID, CategoryID, FeedID, TagID};

use crate::app::App;

#[derive(Debug, Clone)]
pub enum MarkAllReadSource {
    All,
    Feed(FeedID),
    Category(CategoryID),
    Tag(TagID),
    Custom(Box<ArticleFilter>),
}

#[derive(Debug, Clone)]
pub struct UndoMarkReadAction {
    pub source_action: MarkAllReadSource,
    pub article_ids: Vec<ArticleID>,
}

impl UndoMarkReadAction {
    pub fn execute(self) {
        App::default()
            .main_window()
            .content_page()
            .article_list_column()
            .start_mark_all_read();

        App::set_articles_read(self.article_ids);
    }
}
